-- ----------------------------------------------------------------
-- 9.3 Data Changes for SASAPP 
-- Copyright (c) 2010-2011 by SAS Institute Inc., Cary, NC 27513
-- 
-- Supported DBMS: SAS, DB2, MSSQL, MYSQL, ORACLE, POSTGRES
-- ----------------------------------------------------------------

--
-- Improved indexing
--
create index SAS_AUDIT_IX01 on SAS_AUDIT (OBJECT_TYPE_ID, OBJECT_ID);
create index SAS_AUDIT_IX02 on SAS_AUDIT (OBJECT_TYPE_ID, TIMESTAMP_DTTM);
create index SAS_AUDIT_ENTRY_IX01 on SAS_AUDIT_ENTRY (AUDIT_ID);


--
-- New values for SAS_TYPE_ACTION introduced in 9.3
--
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Move',39);
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Rename',40);
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('ScheduledBatch');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('ScheduledDistribution');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('StatusChange');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('SendEmail');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Read');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Open');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('View');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Cancel');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Release');
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Register', 49);
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Unregister', 50);
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('RegisterAll', 51);
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Purge', 52);
insert into SAS_TYPE_ACTION (TYPE_ACTION_CD, TYPE_ACTION_ID) values('Save', 53);


--
-- New values for SAS_TYPE_OBJECT introduced in 9.3
--
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('job', 10);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('jobdefinition', 11);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('taskdefinition',12);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('fileref',13);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('libref',14);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.binaryStreamService',15);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.dataService',16);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.dataConnectionService',17);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.datasetService',18);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.fileService',19);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.filerefService',21);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.formatService',22);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.languageService',23);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.librefService',24);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.textStreamService',25);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.utilitiesService',26);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('sas.svcs.workspaceService',27);

insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Unknown',-1,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Folder',28,1,1,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('RootFolder',29,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('VirtualFolder',30,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Library',31,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Table',32,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Column',33,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Application',20,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('directive',34,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.PooledWorkspace',35,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.StoredProcess',36,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.Workspace',37,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Spawner.IOM',38,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.PooledWorkspace',39,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.StoredProcess',40,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Workspace',41,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('ApplicationServer',42,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Channel',43,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('ContentSubscriber',44,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('EventSubscriber',45,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('MessageQueue',46,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('PublishPackage',47,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('ResultPackage',48,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Login',49,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Machine',50,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Directory',51,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('StoredProcess',52,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.OLAP',53,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.OLAP',54,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.Metadata',55,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Metadata',56,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.Connect',57,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Connect',58,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.TableServer',59,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.TableServer',60,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Spawner.Connect',61,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('HttpServer',62,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Share',63,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.SasInProcess',64,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.OperatingSystem',65,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.JavaBatch',66,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.DataStepBatch',67,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.OperatingSystem',68,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.JavaBatch',69,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.DataStepBatch',70,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Oracle',71,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.Grid',72,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Grid',73,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.GridMonitor',74,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('SystemFolder',75,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('FavoritesFolder',76,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('SearchFolder',77,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('FavoritesGroup',78,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('JcrFolder',79,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('WorkflowTemplate',80,0,0,1);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('ContentDocument',82,0,0,1);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('File',83,0,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('UserFolder',85,1,0,0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('DeployedFlow',86);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('Server.Scheduler',87);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID) values('DeployedJob',88);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.Federation', 89, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Federation', 90, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer.Framework', 91, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.Framework', 92, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server', 93, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('LogicalServer', 94, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.MQPolling', 95, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Server.SPDS', 96, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Report', 98, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Report.Image', 99, 0, 0, 0);
insert into SAS_TYPE_OBJECT (TYPE_OBJECT_CD, TYPE_OBJECT_ID, CONTAINER, LIFECYCLABLE, VERSIONABLE) values('Report.Component', 100, 0, 0, 0);


--
-- New values for SAS_KEYGEN introduced in 9.3
--
insert into SAS_KEYGEN VALUES ('sasapp/alertexpiry', 1);

--
-- Update schema version number 
--
update SAS_SCHEMA_INFO set SCHEMA_VERSION_NO=4;
