-- ----------------------------------------------------------------
-- SASAPP Schema definition script: Delegation service 
-- Copyright (c) 2010-2011 by SAS Institute Inc., Cary, NC 27513
-- 
-- Supported DBMS: ORACLE
-- ----------------------------------------------------------------

-- -----------------------------------------------------------------------
-- SAS_DELEGATION                                                          
-- -----------------------------------------------------------------------

create sequence SAS_DELEGATION_SEQ;

create table SAS_DELEGATION
(
	DELEGATION_ID number(38,0) not null,
	DELEGATE_NAME varchar2(128) not null,
	DELEGATOR_NAME varchar2(128) not null,
	START_DATE number(38,0) not null,
	EXPIRATION_DATE number(38,0) not null,
	DELEGATOR_SUBJECT blob not null,
	constraint DELEGATION_PK primary key (DELEGATION_ID)
);

create trigger SAS_DELEGATION_TRG
before insert on SAS_DELEGATION
for each row
begin
	select SAS_DELEGATION_SEQ.nextval into :new.DELEGATION_ID from dual;
end;
-- if executing in sqlplus replace the second semi-colon with a slash.
-- ;
/