-- ----------------------------------------------------------------
-- SASAPP Schema definition script: Workflow
-- Copyright (c) 2010-2011 by SAS Institute Inc., Cary, NC 27513
-- 
-- Supported DBMS: ORACLE
-- ----------------------------------------------------------------


create table SAS_WF_CONDITIONAL_CHANGE
(
   REAL_ID number(19,0) not null,
   PRECONDITION_FLG number(1,0),
   CONDITION_TYPE_NO number(10,0),
   CHANGE_TYPE_NO number(10,0),
   PROCESS_ID number(19,0),
   PARENT_ID number(19,0),
   CONDITION_TARGET_PROCESS_ID number(19,0),
   CONDITION_TARGET_STATE_ID number(10,0),
   CONDITION_TARGET_STATUS_ID number(19,0),
   CHANGE_STATUS_ID number(19,0),
   CHANGE_STATE_NO number(10,0),
      constraint WF_CONDITIONAL_CHANGE_PK primary key (REAL_ID)
);

create table SAS_WF_EVENT
(
   REAL_ID number(19,0) not null,
   NAME_NM varchar2(255 char),
   SOURCE_TXT varchar2(255 char),
   SCOPE_ID varchar2(255 char),
      constraint WF_EVENT_PK primary key (REAL_ID)
);

create table SAS_WF_MEDIATION_OBJECT
(
   REAL_ID number(19,0) not null,
   WORKFLOW_OBJECT_ID varchar2(255 char) not null unique,
   LABEL_NM varchar2(255 char),
      constraint WF_MEDIATION_OBJECT_PK primary key (REAL_ID)
);

create table SAS_WF_OPERAND
(
   REAL_ID number(19,0) not null,
   PROCESS_ID number(19,0),
   IS_ROOT_FLG number(1,0),
   DESCRIPTION_TXT varchar2(4000 char),
   SCOPE_FLG number(1,0),
   INDEX_VALUE_TXT varchar2(4000 char),
   LARGE_VALUE_TXT blob,
   XML_VALUE_TXT blob,
   SCHEMA_TXT blob,
   WORKFLOW_OBJECT_ID varchar2(255 char) not null unique,
   LABEL_NM varchar2(255 char),
   NUMBER_VALUE_NO number(19,2),
   DATE_VALUE_DTTM timestamp,
   LABELED_ENTITY_ID  varchar2(255 char),
   RB_KEY_FOR_NAME_TXT varchar2(255 char),
   RB_KEY_FOR_DESC_TXT varchar2(255 char),   
      constraint WF_OPERAND_PK primary key (REAL_ID)
);



create table SAS_WF_OPERAND_ATTRIBUTES
(
   OPERAND_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_OPERAND_ATTRIBUTES_PK primary key (OPERAND_ID, NAME_NM)
);

create table SAS_WF_OPERAND_METADATA
(
   OPERAND_ID number(19,0) not null,
   VALUE_TXT blob,
   NAME_NM varchar2(255 char) not null,
      constraint WF_OPERAND_METADATA_PK primary key (OPERAND_ID, NAME_NM)
);

create table SAS_WF_PERSISTENT
(
   REAL_ID number(19,0) not null,
      constraint WF_PERSISTENT_PK primary key (REAL_ID)
);

create table SAS_WF_POLICY
(
   REAL_ID number(19,0) not null,
   PROCESS_ID number(19,0),
   IS_ROOT_FLG number(1,0),
   DESCRIPTION_TXT varchar2(4000 char),
   EVENT_SOURCE_TXT varchar2(255 char),
   EVENT_NAME_TXT varchar2(255 char),
   LANGUAGE_TXT varchar2(255 char),
   SECURITY_POLICY_TXT varchar2(4000 char),
   SOURCE_CODE_TXT varchar2(4000 char),
   SOURCE_CODE_TYPE_TXT number(10,0),
   WORKFLOW_OBJECT_ID varchar2(255 char) not null unique,
   LABEL_NM varchar2(255 char),
   LABELED_ENTITY_ID  varchar2(255 char),
   RB_KEY_FOR_NAME_TXT varchar2(255 char),
   RB_KEY_FOR_DESC_TXT varchar2(255 char),   
      constraint WF_POLICY_PK primary key (REAL_ID)
);


create table SAS_WF_POLICY_ATTRIBUTES
(
   POLICY_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_POLICY_ATTRIBUTES_PK primary key (POLICY_ID, NAME_NM)
);

create table SAS_WF_POLICY_LP_EVENT_ATTR
(
   POLICY_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_POLICY_LP_EVENT_ATTR_PK primary key (POLICY_ID, NAME_NM)
);

create table SAS_WF_POLICY_METADATA
(
   POLICY_ID number(19,0) not null,
   VALUE_TXT blob,
   NAME_NM varchar2(255 char) not null,
      constraint WF_POLICY_METADATA_PK primary key (POLICY_ID, NAME_NM)
);

create table SAS_WF_POLICY_STR_EVENT_ATTR
(
   POLICY_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_POLICY_STR_EVENT_ATTR_PK primary key (POLICY_ID, NAME_NM)
);

create table SAS_WF_PROCESS
(
   REAL_ID number(19,0) not null,
   IS_DELETED_FLG number(1,0),
   STATE_NO number(10,0),
   PARENT_ID number(19,0),
   PROCESS_DEFINITION_ID number(19,0),
   ROOT_PROCESS_ID number(19,0),
   IS_ROOT_FLG number(1,0),
   DESCRIPTION_TXT varchar2(4000 char),
   IS_DEFINITION_FLG number(1,0),
   START_DATE_DTTM timestamp,
   END_DATE_DTTM timestamp,
   ACCESS_TAG_ID number(19,0),
   SCHEDULED_DATE_DTTM timestamp,
   DUE_DATE_DTTM timestamp,
   IS_LOCKED_FLG number(1,0),
   WORKFLOW_OBJECT_ID varchar2(255 char) not null unique,
   LABEL_NM varchar2(255 char),
   VERSION_NM varchar2(255 char),
   LABELED_ENTITY_ID  varchar2(255 char),
   RB_KEY_FOR_NAME_TXT varchar2(255 char),
   RB_KEY_FOR_DESC_TXT varchar2(255 char),   
      constraint WF_PROCESS_PK primary key (REAL_ID)
);

create table SAS_WF_PROCESS_ACE
(
   REAL_ID number(19,0) not null,
   ASSIGNEE_ID number(19,0),
   TYPE_NO number(10,0),
   NAME_NM varchar2(255 char),
   ROLE_NM varchar2(255 char),
      constraint WF_PROCESS_ACE_PK primary key (REAL_ID)
);

create table SAS_WF_PROCESS_ATTR
(
   PROCESS_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_PROCESS_ATTR_PK primary key (PROCESS_ID, NAME_NM)
);

create table SAS_WF_PROCESS_CURRENT_STATUS
(
   PROCESS_ID number(19,0) not null,
   STATUS_ID number(19,0) not null,
      constraint WF_PROCESS_CURRENT_STATUS_PK primary key (PROCESS_ID, STATUS_ID)
);

create table SAS_WF_PROCESS_METADATA
(
   PROCESS_ID number(19,0) not null,
   VALUE_TXT blob,
   NAME_NM varchar2(255 char) not null,
      constraint WF_PROCESS_METADATA_PK primary key (PROCESS_ID, NAME_NM)
);

create table SAS_WF_STATUS
(
   REAL_ID number(19,0) not null,
   PROCESS_ID number(19,0),
   IS_ROOT_FLG number(1,0),
   TYPE_TXT varchar2(4000 char),
   SCOPE_FLG number(1,0),
   WORKFLOW_OBJECT_ID varchar2(255 char) not null unique,
   LABEL_NM varchar2(255 char),
   LABELED_ENTITY_ID  varchar2(255 char),
   RB_KEY_FOR_NAME_TXT varchar2(255 char),
   RB_KEY_FOR_DESC_TXT varchar2(255 char),   
      constraint WF_STATUS_PK primary key (REAL_ID)
);


create table SAS_WF_STATUS_ATTRIBUTES
(
   STATUS_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_STATUS_ATTRIBUTES_PK primary key (STATUS_ID, NAME_NM)
);

create table SAS_WF_STATUS_METADATA
(
   STATUS_ID number(19,0) not null,
   VALUE_TXT blob,
   NAME_NM varchar2(255 char) not null,
      constraint WF_STATUS_METADATA_PK primary key (STATUS_ID, NAME_NM)
);

create table SAS_WF_TIMERSPEC
(
   REAL_ID number(19,0) not null,
   PROCESS_ID number(19,0),
   SCHEDULE_DATE_DTTM timestamp,
   SCHEDULE_EXPRESSION_TXT varchar2(255 char),
   REPEAT_EXPRESSION_TXT varchar2(255 char),
   REPEAT_CNT number(10,0),
   END_DATE_DTTM timestamp,
   END_EXPRESSION_TXT varchar2(255 char),
   CALENDAR_TXT varchar2(255 char),
   DESCRIPTION_TXT varchar2(255 char),
   SAS_WORKFLOW_EVENT_NO number(19,0),
   STARTED_TIMER_ID varchar2(255 char),
      constraint WF_TIMERSPEC_PK primary key (REAL_ID)
);

create table SAS_WF_TIMER_LP_EVENT_ATTR
(
   SAS_WORKFLOW_EVENT_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_TIMER_LP_EVENT_ATTR_PK primary key (SAS_WORKFLOW_EVENT_ID, NAME_NM)
);

create table SAS_WF_TIMER_STRING_EVENT_ATTR
(
   SAS_WORKLFOW_EVENT_ID number(19,0) not null,
   VALUE_TXT varchar2(4000 char),
   NAME_NM varchar2(255 char) not null,
      constraint WF_TIMER_STRING_EVENT_ATTR_PK primary key (SAS_WORKLFOW_EVENT_ID, NAME_NM)
);

create table SAS_WF_TAGS
(
    TAG_ID number(19,0) not null,
    TAG_NM varchar2(255 char) not null unique,
       constraint WF_TAGS_PK primary key (TAG_ID) enable
);

create table SAS_WF_TAGS_ASSIGNED
(
    PROCESS_ID number(19,0) not null,
    TAG_ID number(19,0) not null
);

create index CONDCHANGE_TARGET_PROC_IX on SAS_WF_CONDITIONAL_CHANGE (CONDITION_TARGET_PROCESS_ID);

create index CONDCHANGE_PROC_IX on SAS_WF_CONDITIONAL_CHANGE (PROCESS_ID);

create index CONDCHANGE_PARENT_IX on SAS_WF_CONDITIONAL_CHANGE (PARENT_ID);

alter table SAS_WF_CONDITIONAL_CHANGE
   add constraint CONDITIONAL_CHANGE_FK01
   foreign key (CHANGE_STATUS_ID) references SAS_WF_STATUS;

alter table SAS_WF_CONDITIONAL_CHANGE
   add constraint CONDITIONAL_CHANGE_FK02
   foreign key (CONDITION_TARGET_STATUS_ID) references SAS_WF_STATUS;

alter table SAS_WF_CONDITIONAL_CHANGE
   add constraint CONDITIONAL_CHANGE_FK03
   foreign key (CONDITION_TARGET_PROCESS_ID) references SAS_WF_PROCESS;

alter table SAS_WF_CONDITIONAL_CHANGE
   add constraint CONDITIONAL_CHANGE_FK04
   foreign key (PARENT_ID) references SAS_WF_CONDITIONAL_CHANGE;

alter table SAS_WF_CONDITIONAL_CHANGE
   add constraint CONDITIONAL_CHANGE_FK05
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;

create index OPERAND_ISROOT_IX on SAS_WF_OPERAND (IS_ROOT_FLG);

create index OPERAND_PROCESS_IX on SAS_WF_OPERAND (PROCESS_ID);

alter table SAS_WF_OPERAND
   add constraint OPERAND_FK01
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;


alter table SAS_WF_OPERAND_ATTRIBUTES
   add constraint OPERAND_ATTRIBUTES_FK01
   foreign key (OPERAND_ID) references SAS_WF_OPERAND;

alter table SAS_WF_OPERAND_METADATA
   add constraint OPERAND_METADATA_FK01
   foreign key (OPERAND_ID) references SAS_WF_OPERAND;

create index POLICY_ISROOT_IX on SAS_WF_POLICY (IS_ROOT_FLG);

create index POLICY_PROCESS_IX on SAS_WF_POLICY (PROCESS_ID);

alter table SAS_WF_POLICY
   add constraint POLICY_FK01
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;


alter table SAS_WF_POLICY_ATTRIBUTES
   add constraint POLICY_ATTRIBUTES_FK01
   foreign key (POLICY_ID) references SAS_WF_POLICY;

alter table SAS_WF_POLICY_LP_EVENT_ATTR
   add constraint POLICY_LP_EVENT_ATTR_FK01
   foreign key (POLICY_ID) references SAS_WF_POLICY;

alter table SAS_WF_POLICY_METADATA
   add constraint POLICY_METADATA_FK01
   foreign key (POLICY_ID) references SAS_WF_POLICY;

alter table SAS_WF_POLICY_STR_EVENT_ATTR
   add constraint POLICY_STR_EVENT_ATTR_FK01
   foreign key (POLICY_ID) references SAS_WF_POLICY;

create index PROCESS_ISROOT_IX on SAS_WF_PROCESS (IS_ROOT_FLG);

create index PROCESS_ROOT_IX on SAS_WF_PROCESS (ROOT_PROCESS_ID);

create index PROCESS_ISDEFINITION_IX on SAS_WF_PROCESS (IS_DEFINITION_FLG);

create index PROCESS_IS_LOCKED_IX on SAS_WF_PROCESS (IS_LOCKED_FLG);

create index PROCESS_DEFINITION_IX on SAS_WF_PROCESS (PROCESS_DEFINITION_ID);

create index PROCESS_PARENT_IX on SAS_WF_PROCESS (PARENT_ID);

create index PROCESS_STATE_IX on SAS_WF_PROCESS (STATE_NO);

alter table SAS_WF_PROCESS
   add constraint PROCESS_FK01
   foreign key (ROOT_PROCESS_ID) references SAS_WF_PROCESS;

alter table SAS_WF_PROCESS
   add constraint PROCESS_FK02
   foreign key (PROCESS_DEFINITION_ID) references SAS_WF_PROCESS;

alter table SAS_WF_PROCESS
   add constraint PROCESS_FK03
   foreign key (PARENT_ID) references SAS_WF_PROCESS;

create index PROCESS_ACE_TYPE_IX on SAS_WF_PROCESS_ACE (TYPE_NO);

create index PROCESSACE_ASSIGNEE_IX on SAS_WF_PROCESS_ACE (ASSIGNEE_ID);

alter table SAS_WF_PROCESS_ACE
   add constraint PROCESS_ACE_FK01
   foreign key (ASSIGNEE_ID) references SAS_WF_PROCESS;

alter table SAS_WF_PROCESS_ATTR
   add constraint PROCESS_ATTR_FK01
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;

alter table SAS_WF_PROCESS_CURRENT_STATUS
   add constraint PROCESS_CURRENT_STATUS_FK02
   foreign key (STATUS_ID) references SAS_WF_STATUS;

alter table SAS_WF_PROCESS_CURRENT_STATUS
   add constraint PROCESS_CURRENT_STATUS_FK01
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;

alter table SAS_WF_PROCESS_METADATA
   add constraint PROCESS_METADATA_FK01
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;

create index STATUS_ISROOT_IX on SAS_WF_STATUS (IS_ROOT_FLG);

create index STATUS_PROCESS_IX on SAS_WF_STATUS (PROCESS_ID);

alter table SAS_WF_STATUS
   add constraint STATUS_FK01
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;


alter table SAS_WF_STATUS_ATTRIBUTES
   add constraint STATUS_ATTRIBUTES_FK01
   foreign key (STATUS_ID) references SAS_WF_STATUS;

alter table SAS_WF_STATUS_METADATA
   add constraint STATUS_METADATA_FK01
   foreign key (STATUS_ID) references SAS_WF_STATUS;

create index TIMERSPEC_PROCESS_IX on SAS_WF_TIMERSPEC (PROCESS_ID);

alter table SAS_WF_TIMERSPEC
   add constraint TIMERSPEC_FK01
   foreign key (SAS_WORKFLOW_EVENT_NO) references SAS_WF_EVENT;

alter table SAS_WF_TIMERSPEC
   add constraint TIMERSPEC_FK02
   foreign key (PROCESS_ID) references SAS_WF_PROCESS;

alter table SAS_WF_TIMER_LP_EVENT_ATTR
   add constraint TIMER_LP_EVENT_ATTR_FK01
   foreign key (SAS_WORKFLOW_EVENT_ID) references SAS_WF_EVENT;

alter table SAS_WF_TIMER_STRING_EVENT_ATTR
   add constraint TIMER_STRING_EVENT_ATTR_FK01
   foreign key (SAS_WORKLFOW_EVENT_ID) references SAS_WF_EVENT;

create index CONDCHANGE_CHG_STATUS_IX on SAS_WF_CONDITIONAL_CHANGE (CHANGE_STATUS_ID);
create index CONDCHANGE_TARGET_STATUS_IX on SAS_WF_CONDITIONAL_CHANGE (CONDITION_TARGET_STATUS_ID);
create index PROCESS_CS_STATUS_IX on SAS_WF_PROCESS_CURRENT_STATUS (STATUS_ID);
create index TIMERSPEC_WF_EVENT_NO_IX on SAS_WF_TIMERSPEC (SAS_WORKFLOW_EVENT_NO);

alter table SAS_WF_TAGS_ASSIGNED
    add constraint TAG_ID_FK01
    foreign key (TAG_ID) references SAS_WF_TAGS;

create index TAG_ID_IX on SAS_WF_TAGS_ASSIGNED (TAG_ID);
