-- ----------------------------------------------------------------
-- SASAPP Schema definition script: Delegation service 
-- Copyright (c) 2010-2011 by SAS Institute Inc., Cary, NC 27513
-- 
-- Supported DBMS: SAS
-- ----------------------------------------------------------------

-- -----------------------------------------------------------------------
-- SAS_DELEGATION                                                          
-- -----------------------------------------------------------------------

create table SAS_DELEGATION
(
   DELEGATION_ID bigint not null primary key,
   DELEGATE_NAME varchar(128) not null,
   DELEGATOR_NAME varchar(128) not null,
   START_DATE bigint not null,
   EXPIRATION_DATE bigint not null,
   DELEGATOR_SUBJECT blob not null
);

CREATE GENERATOR SAS_DELEGATION_GEN;
SET GENERATOR SAS_DELEGATION_GEN TO 0;

-- This must be on one line due to TSSQL 
CREATE TRIGGER SAS_DELEGATION_BI FOR SAS_DELEGATION ACTIVE BEFORE INSERT POSITION 0 AS BEGIN if (NEW.DELEGATION_ID is NULL) then NEW.DELEGATION_ID = GEN_ID(SAS_DELEGATION_GEN, 1); END;
